#!/usr/bin/perl -w

use strict;
use CoreSim::Init; 
 
#set autoflush 
$| =1;  
 

sub main{
	
	my $maxNodesInFingerTable = 32; 
	my $maxNodesInChordRing = 2**$maxNodesInFingerTable;
	my $_DEBUG = 0;
	my $path1;
	my $path2;
	
	#the variables that determine the number of nodes from the chordRing for which this process will compute the finger tables
	my $startPosition;
	my $endPosition;
	my $generalCase;
	my $readFingerTables;
	my $readFilteredPrefixes;
	my $writeFingerTables;
	my $writeFilteredPrefixes;
	
	if (scalar(@ARGV)){
		$startPosition = $ARGV[0];
		$endPosition = $ARGV[1];
		$generalCase = $ARGV[2];
		$readFingerTables = $ARGV[3];
		$writeFingerTables=$ARGV[4];
		$readFilteredPrefixes = $ARGV[5];
		$writeFilteredPrefixes=$ARGV[6];
		$path1 = $ARGV[7];
		$path2 = $ARGV[8];
		
		printf("Arguments!start position = %s end position = %s generalCase= %s\n rfTable=%s rfPrefixes=%s wfTable=%s wfPrefixes=%s \npath1=%s \npath2=%s\n\n", 
				$startPosition, $endPosition, $generalCase, $readFingerTables, $readFilteredPrefixes, $writeFingerTables, $writeFilteredPrefixes, $path1, $path2) if($_DEBUG);
		
	}else{
		$startPosition = 0;
		$endPosition = undef;
		$generalCase = 0;
		printf("the start position: %s and the end position is undefined \n", $startPosition)if ($_DEBUG);
	}
	
	if (!defined($path1)){
		$path1 = "";
		$path2 = "";
	}
	
	#if generalCase is not defined then use the "private" topology
	if (!defined($generalCase)){
		$generalCase=0;
	}
	
	#debug!!!
	$generalCase=1;
	$readFingerTables =1;
	$readFilteredPrefixes=1;
#	$writeFilteredPrefixes=1;
#	$writeFingerTables =0;
#	$writeSortedAndFilteredPrefixListToFile = "$path1/sortedAndFilteredPrefixList.txt";
#	$readSortedAndFilteredPrefixListFromFile = "$path1/sortedAndFilteredPrefixList.txt";

	
	my @filePath;
	if ($generalCase==0){
		@filePath = ("$path1/ipl.txt", "$path1/ipm.txt", "$path1/oa.txt");
	}else{
		@filePath = ("$path1/inter_pop_links.txt", 
					 "$path1/ip_to_pop_mapping.txt", 
					 "$path1/origin_as_mapping.txt",
					 "$path1/sortedAndFilteredPrefixList.txt",
					 "$path1/prefix_to_rir.txt",
					 "$path1/rootServers.txt");
	}
	
	my $readFingerTablesFromFile;
	if (defined($readFingerTables) && ($readFingerTables!=0)) {
		$readFingerTablesFromFile = "$path1/fingerTables.txt";
		
	}else{
		$readFingerTablesFromFile = undef;
	}
	
	
	my $writeFingerTablesToFile;
	if(defined($writeFingerTables) && ($writeFingerTables!=0)){	
		if (defined($endPosition)){
			$writeFingerTablesToFile = "$path2/finger_tables$startPosition"."_"."$endPosition.txt";	
		}else{
			$writeFingerTablesToFile = "$path2/fingerTables.txt";
		}
	}else{
		$writeFingerTablesToFile = undef;
	}
	
	my $readSortedAndFilteredPrefixListFromFile;
	if (defined($readFilteredPrefixes) && ($readFilteredPrefixes !=0 )){
		$readSortedAndFilteredPrefixListFromFile = "$path1/sortedAndFilteredPrefixList.txt";
	}else{
		$readSortedAndFilteredPrefixListFromFile = undef;
	}
	
	my $writeSortedAndFilteredPrefixListToFile;
	if (defined($writeFilteredPrefixes) && ($writeFilteredPrefixes !=0 )){
		$writeSortedAndFilteredPrefixListToFile = "$path2/sortedAndFilteredPrefixList.txt";
	}else{
		$writeSortedAndFilteredPrefixListToFile = undef;
	}
	
	my $xmlRPCServer = "";
	my $tracePath = "$path1/traceFile.txt";
	my $dbiPlanePath = "$path1/iPlane.db";
	my $dbEstimatorPath = "$path1/estimator.db";
	my $geoLiteCityFile = "$path1/GeoLiteCity.dat";
	my $simulationID = 1;
	
	#choose the type of resolver ( for Chord and TREE)
	my $resolverType = 1;
	
	my $init = CoreSim::Init->new($xmlRPCServer, \@filePath, $startPosition, $endPosition, $writeFingerTablesToFile, $readFingerTablesFromFile,
								$writeSortedAndFilteredPrefixListToFile, $readSortedAndFilteredPrefixListFromFile, $tracePath, $dbiPlanePath,
								$dbEstimatorPath, $resolverType, $geoLiteCityFile,$path1, $path2, $simulationID, $_DEBUG);
										
	$init->buildMSAndITR(2, "130.104.0.0/16");
	$init->runScenario1();
	
}


&main();
